#include <stdio.h>
#include <stdlib.h>

char enter[2];

typedef struct TLivro {
	int codigo;
	char titulo[100];
	char autor[100];
	char dataPublicacao[11];
	int edicao;
	char cidade[30];
	char editora[30];
	struct TLivro *prox;
} *Livro;

/* Lê do teclado os dados do livro e retorna a estrutura montada. */
Livro lerDadosLivro() {
	Livro l = (Livro)malloc(sizeof(struct TLivro));
	l->prox = NULL;
	printf("Informe os seguintes dados para cadastro do livro:\n");

	printf("Código: ");
	scanf("%d", &l->codigo);
	gets(enter);

	printf("Título: ");
	gets(l->titulo);

	printf("Autor: ");
	gets(l->autor);

	printf("Data de publicação: ");
	gets(l->dataPublicacao);

	printf("Edição: ");
	scanf("%d", &l->edicao);
	gets(enter);

	printf("Cidade: ");
	gets(l->cidade);

	printf("Editora: ");
	gets(l->editora);
	
	return l;
}

/* Imprime os dados do livro na tela. */
void imprimirLivro(Livro l) {
	printf("[%d] %s (%s)\n", l->codigo, l->titulo, l->autor);
	printf("\t-> %dª edição, publicada em %s por %s (%s)\n", l->edicao, l->dataPublicacao, l->editora, l->cidade);
}

main() {
	Livro prim, ult, atual;
	char resposta;
	int i = 0;
	
	// Cadastra quantos livros quiser.
	prim = ult = NULL;
	do {
		atual = lerDadosLivro();
		
		if (ult == NULL) prim = ult = atual;
		else ult = ult->prox = atual;
		
		printf("\nDeseja cadastrar mais um livro? (S/N) ");
		scanf("%c", &resposta);
	} while (resposta == 's' || resposta == 'S');
	
	// Imprime os dados dos livros.
	atual = prim;
	while (atual) {
		printf("Livro %d:\n", ++i);
		imprimirLivro(atual);
		atual = atual->prox;
	}
}
